



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MapReduce job.setNumReduceTasks(0)思考</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MapReduce job.setNumReduceTasks(0)思考</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-26 15:47:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一.概述</strong></p>
<p>在&nbsp;<a href="http://zy19982004.iteye.com/blog/2037549" rel="external nofollow noreferrer">http://zy19982004.iteye.com/blog/2037549</a>的最后曾经提到过，这里再详细探讨一下。</p>
<p><strong>二.job.setNumReduceTasks(0)唯一影响的是map结果的输出方式</strong></p>
<p>当job.setNumReduceTasks(0)时，即没有reduce阶段，此时唯一影响的就是map结果的输出方式</p>
<ol><li>如果有reduce阶段，map的结果被flush到硬盘&nbsp;，作为reduce的输入；&nbsp;reduce的结果将被OutputFormat的RecordWriter写到指定的地方（setOutputPath），作为整个程序的输出&nbsp;。</li>
<li>如果没有reduce阶段，map的结果将直接被OutputFormat的RecordWriter写到指定的地方&nbsp;（setOutputPath），作为整个程序的输出&nbsp;。</li></ol>
<p>而OutputFormat可以是普通的FileOutputFormat等，也可以是一个空的OutputFormat如NullOutputFormat。</p>
<p>所以有无reduce和OutputFormat的多样性将组合出现以下情形（这个组合其实没什么意义，只是为了更加清楚而已）</p>
<ol><li>有reduce</li>
<ol><li>reduce的结果不需要输出到文件，如reduce里直接将结果插入HBase，此时可以采用NullOutputFormat，当然就不需要setOutputPath。</li>
<li>reduce的结果需要输出到文件，如采用FileOutputFormat，需要setOutputPath。</li></ol>
<li>无reduce</li>
<ol><li>map的结果需要不输出到文件，如map里直接将结果插入HBase，此时可以采用NullOutputFormat，当然就不需要setOutputPath。</li>
<li>map的结果需要输出到文件，如采用FileOutputFormat，需要setOutputPath。</li></ol></ol>
<p><strong>三.总结</strong></p>
<ol><li>有无reduce决定map结果的输出方式。有reduce时reduce的结果作为整个程序的输出；无reduce时，map的结果作为整个程序的输出。</li>
<li>如NullOutputFormat层面上OutputFormat的不需要指定OutputPath；其他如FileOutputFormat需要指定，不然
<pre class="prettyprint linenums">Exception in thread "main" org.apache.hadoop.mapred.InvalidJobConfException: Output directory not set.<br />
	at org.apache.hadoop.mapreduce.lib.output.FileOutputFormat.checkOutputSpecs(FileOutputFormat.java:138)</pre></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn1ex38.html">WEB开发最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdw6xx9.html">&lbrack;moka同学收藏&rsqb;Vim升华之树形目录插件NERDTree安装图解</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77lzgq.html">墙裂推荐一本案例驱动的PhoneGap入门书，早看早收货</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oy32eq.html">asp&period;net core获取自定义json的配置内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m661r9.html">Codeforces Round &num;344 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnezokq.html">Linux基础命令介绍七：网络传输与安全 wget curl rsync iptables</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8el12kq.html">linux重启命令学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5gol9.html">NGUI Tutorial 3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w6ywwq.html">ACM&mdash;&mdash;Digital Roots</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdp32y8.html">Prototype&colon;Copy和Clone</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvm21oq.html">&lbrack;BZOJ 1576&rsqb; &lbrack;Usaco2009 Jan&rsqb; 安全路经Travel 【树链剖分】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj10y1q.html">query 原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjrdx38.html">大话PROFINET</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1xymgq.html">poj 3294</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25jwv3q.html">spring suite tool 添加namespace时只有bean一个</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjxkje9.html">Android项目实战（三十二）：圆角对话框Dialog</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em0vwe9.html">dialog弹层背景overlayer实现的方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvej0my9.html">解决ie6、ie7下float为right换行的情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko4wm7q.html">UNIX 域套接字&mdash;&mdash;UNIX domain socket</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvnmo2q.html">LeetCode&mdash;&mdash;Basic Calculator</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqv04ry8.html">Python学习基本</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93nej0q.html">http状态消息</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv06p18.html">liunx 下 部署并运行java项目（非web）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyrp4m8.html">silverlight导出excel</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q207539.html">《Eclipse中的一些快捷键》</a>
			</li>
						<li><a href="https://www.batexi.com/a/495j530q.html">css2----兼容----ie67的3像素bug</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9656xvq.html">UART接口基本知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mwn66q.html">CSS实现三角形</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r1dr78.html">C语言状态机模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy51wg9.html">新手码农浅谈观察者模式（java语言简单实现）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
